import React, { KeyboardEvent } from "react";
export interface BasicAction {
    label?: string;
    image?: string;
    onClick?: () => void;
}
export declare type AddtionalResultProps = {
    rating: number;
    keyShortcut: string;
};
declare type KeyShortcut = () => {
    label: string;
    isPressed: (e: KeyboardEvent) => boolean;
};
declare type ActionKeyShortcut<MyAction> = (result: {
    index: number;
    action: MyAction;
}) => {
    label: string;
    isPressed: (e: KeyboardEvent) => boolean;
};
export interface Props<MyAction extends BasicAction> {
    renderResultRow?: (result: MyAction & AddtionalResultProps) => Element;
    actions: MyAction[];
    getSearchKeywordsForAction?: (action: MyAction) => string[];
    onActionPress?: (action: MyAction) => void;
    getKeyShortcutForResult?: ActionKeyShortcut<MyAction>;
    getKeyShortcutForOpen?: KeyShortcut;
    getKeyShortcutForClose?: KeyShortcut;
    getRatingForKeywords?: (keywords: string[], searchQuery: string) => number;
    showTopNResults?: number;
}
export declare const ShortcutPopup: <MyAction extends BasicAction = BasicAction>(p: Props<MyAction>) => React.ReactElement | null;
export default ShortcutPopup;
