'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css = "/* add css styles here (optional) */\n\n.styles_test__32Qsm {\n  display: inline-block;\n  margin: 2em auto;\n  border: 2px solid #000;\n  font-size: 2em;\n}\n.styles_popupContainer__217in {\n  position: absolute;\n  top: 0;\n  left: 0;\n  width: 100vw;\n  height: 100vh;\n  margin: 0;\n  padding-top: 32vh;\n  flex: 1;\n  display: flex;\n  align-items: flex-start;\n  justify-content: center;\n  box-sizing: border-box;\n}\n.styles_popup__2Lia6 {\n  width: 450px;\n  border-radius: 15px;\n  padding-bottom: 15px;\n  background-color: #e9e9e9;\n  border: 1px solid #111;\n  display: flex;\n  flex-direction: column;\n}\n.styles_searchInput__2b0Yz {\n  border: 0;\n  border-radius: 15px;\n  border-bottom: 1px solid #111;\n  border-bottom-left-radius: 0;\n  border-bottom-right-radius: 0;\n  box-shadow: none;\n  outline: none;\n  font-size: 24px;\n  padding: 20px;\n}\n.styles_searchInput__2b0Yz:focus + .styles_result__SJJfE {\n  background: #fff;\n}\n.styles_result__SJJfE {\n  background: none;\n  color: inherit;\n  border: none;\n  border-bottom: 1px solid #111;\n  font: inherit;\n  cursor: pointer;\n  outline: inherit;\n}\n.styles_result__SJJfE:hover {\n  background: #c8c8c8;\n}\n.styles_result__SJJfE:focus {\n  background: #fff;\n}\n\n\n.styles_container__2pRR5 {\n  flex: 1;\n  display: flex;\n  align-items: center;\n  margin: 10px 15px;\n}\n.styles_label__1nh3o {\n  font-size: 16px;\n}\n.styles_image__24T34 {\n  width: 48px;\n  height: 48px;\n  border-radius: 2px;\n}\n.styles_keyCombinationIndicator__2JpO0 {\n  border: 1px solid #111;\n  border-radius: 1000px;\n  color: #111;\n  margin: 10px;\n  padding: 5px;\n  padding-left: 15px;\n  padding-right: 15px;\n  display: flex;\n  justify-content: center;\n  align-items: center;\n}\n";
var styles = {"test":"styles_test__32Qsm","popupContainer":"styles_popupContainer__217in","popup":"styles_popup__2Lia6","searchInput":"styles_searchInput__2b0Yz","result":"styles_result__SJJfE","container":"styles_container__2pRR5","label":"styles_label__1nh3o","image":"styles_image__24T34","keyCombinationIndicator":"styles_keyCombinationIndicator__2JpO0"};
styleInject(css);

var BasicActionRow = function (_a) {
    var label = _a.label, image = _a.image, keyShortcut = _a.keyShortcut;
    return (React__default.createElement("div", { className: styles.container },
        React__default.createElement("img", { className: styles.image, src: image }),
        React__default.createElement("div", { className: styles.keyCombinationIndicator }, keyShortcut),
        React__default.createElement("div", { className: styles.label }, label)));
};

/**
 * Calculates the Damerau-Levenshtein distance between two strings. https://gist.github.com/IceCreamYou/8396172
 */
function distance(source, target) {
    if (!source)
        return target ? target.length : 0;
    else if (!target)
        return source.length;
    var m = source.length, n = target.length, INF = m + n, score = new Array(m + 2), sd = {};
    for (var i = 0; i < m + 2; i++)
        score[i] = new Array(n + 2);
    score[0][0] = INF;
    for (var i = 0; i <= m; i++) {
        score[i + 1][1] = i;
        score[i + 1][0] = INF;
        sd[source[i]] = 0;
    }
    for (var j = 0; j <= n; j++) {
        score[1][j + 1] = j;
        score[0][j + 1] = INF;
        sd[target[j]] = 0;
    }
    for (var i = 1; i <= m; i++) {
        var DB = 0;
        for (var j = 1; j <= n; j++) {
            var i1 = sd[target[j - 1]], j1 = DB;
            if (source[i - 1] === target[j - 1]) {
                score[i + 1][j + 1] = score[i][j];
                DB = j;
            }
            else {
                score[i + 1][j + 1] =
                    Math.min(score[i][j], Math.min(score[i + 1][j], score[i][j + 1])) + 1;
            }
            score[i + 1][j + 1] = Math.min(score[i + 1][j + 1], score[i1] ? score[i1][j1] + (i - i1 - 1) + 1 + (j - j1 - 1) : Infinity);
        }
        sd[source[i - 1]] = i;
    }
    return score[m + 1][n + 1];
}

var isMac = navigator.platform.toUpperCase().indexOf("MAC") >= 0;
var defaultGetKeyShortcutForResult = function (_a) {
    var index = _a.index;
    return {
        label: (isMac ? "⌘ + " : "ctrl + ") + (index + 1),
        isPressed: function (e) {
            return e.key === String(index + 1) && (e.metaKey || e.ctrlKey);
        }
    };
};
var defaultGetKeyShortcutForOpen = function () {
    return {
        label: isMac ? "⌘ + k" : "ctrl + k",
        isPressed: function (e) {
            return e.key.toLowerCase() === "k" && (e.metaKey || e.ctrlKey);
        }
    };
};
var defaultGetKeyShortcutForClose = function () {
    return {
        label: "esc",
        isPressed: function (e) {
            return (e.key.toLowerCase() === "k" && (e.metaKey || e.ctrlKey)) ||
                e.key.toLowerCase() === "escape";
        }
    };
};
var defaultGetRatingForKeywords = function (keywords, searchQuery) {
    var table = searchQuery
        .toLowerCase()
        .split(" ")
        .reduce(function (acc, query) {
        return acc.concat(keywords.map(function (keyword) {
            return distance(keyword.toLowerCase(), query) /
                Math.max(keyword.length, query.length);
        }));
    }, []);
    var score = table.reduce(function (acc, val) { return acc + Math.pow(val, 1 / 10); }, 0) / table.length;
    return score;
};
var ShortcutPopup = function (_a) {
    var _b = _a.renderResultRow, renderResultRow = _b === void 0 ? function (result) { return (React__default.createElement(BasicActionRow, __assign({}, result))); } : _b, actions = _a.actions, _c = _a.getSearchKeywordsForAction, getSearchKeywordsForAction = _c === void 0 ? function (action) { return (action.label || "").split(" "); } : _c, _d = _a.getKeyShortcutForResult, getKeyShortcutForResult = _d === void 0 ? defaultGetKeyShortcutForResult : _d, _e = _a.getKeyShortcutForOpen, getKeyShortcutForOpen = _e === void 0 ? defaultGetKeyShortcutForOpen : _e, _f = _a.getKeyShortcutForClose, getKeyShortcutForClose = _f === void 0 ? defaultGetKeyShortcutForClose : _f, _g = _a.getRatingForKeywords, getRatingForKeywords = _g === void 0 ? defaultGetRatingForKeywords : _g, _h = _a.onActionPress, onActionPress = _h === void 0 ? function (action) { var _a; return (_a = action.onClick) === null || _a === void 0 ? void 0 : _a.call(action); } : _h, _j = _a.showTopNResults, showTopNResults = _j === void 0 ? 5 : _j;
    var _k = React.useState(false), shown = _k[0], setShown = _k[1];
    var _l = React.useState(""), search = _l[0], setSearch = _l[1];
    var getItemsForSearchQuery = function (searchQuery) {
        if (!searchQuery)
            return [];
        return actions
            .map(function (item) { return (__assign(__assign({}, item), { rating: getRatingForKeywords(getSearchKeywordsForAction(item), searchQuery) })); })
            .sort(function (a, b) { return -b.rating + a.rating; })
            .slice(0, showTopNResults);
    };
    var foundResults = React.useMemo(function () {
        return getItemsForSearchQuery(search).map(function (action, index) { return (__assign(__assign({}, action), { keyShortcut: getKeyShortcutForResult({ index: index, action: action }).label })); });
    }, [search]);
    React.useEffect(function () {
        !shown && setSearch("");
    }, [shown]);
    var executeResultAction = function (result) {
        setShown(false);
        onActionPress(result);
    };
    var handleKeyPress = React.useCallback(function (e) {
        var _a, _b, _c, _d;
        if (!shown && getKeyShortcutForOpen().isPressed(e)) {
            setShown(function (shown) { return !shown; });
            e.preventDefault();
            return;
        }
        if (!shown)
            return;
        if (shown && getKeyShortcutForClose().isPressed(e)) {
            setShown(false);
            e.preventDefault();
            return;
        }
        foundResults.forEach(function (value, index) {
            if (getKeyShortcutForResult({
                index: index,
                action: value
            }).isPressed(e)) {
                executeResultAction(value);
                e.preventDefault();
                return;
            }
        });
        if (e.key === "Enter" && !(document === null || document === void 0 ? void 0 : document.querySelector(".result:focus"))) {
            if (foundResults[0]) {
                executeResultAction(foundResults[0]);
            }
            else {
                setShown(false);
            }
        }
        if (e.keyCode === 38 || e.keyCode === 40) {
            if (document === null || document === void 0 ? void 0 : document.querySelector(".result:focus")) {
                (_b = (_a = document === null || document === void 0 ? void 0 : document.querySelector(".result:focus")) === null || _a === void 0 ? void 0 : _a[e.keyCode === 38 ? "previousSibling" : "nextSibling"]) === null || _b === void 0 ? void 0 : _b.focus();
            }
            else {
                if (e.keyCode === 40) {
                    (_c = document === null || document === void 0 ? void 0 : document.querySelectorAll(".result").item(1)) === null || _c === void 0 ? void 0 : _c.focus();
                }
            }
            e.preventDefault();
            return;
        }
        if (/^[A-Z0-9]$/i.test(e.key)) {
            (_d = document === null || document === void 0 ? void 0 : document.querySelector(".searchInput")) === null || _d === void 0 ? void 0 : _d.focus();
        }
    }, [
        foundResults,
        shown,
        getKeyShortcutForOpen,
        getKeyShortcutForClose,
        getKeyShortcutForResult
    ]);
    React.useEffect(function () {
        window.addEventListener("keydown", handleKeyPress);
        return function () { return window.removeEventListener("keydown", handleKeyPress); };
    }, [handleKeyPress]);
    if (!shown)
        return null;
    return (React__default.createElement("div", { className: styles.popupContainer, onClick: function () { return setShown(false); } },
        React__default.createElement("div", { className: styles.popup, onClick: function (e) { return e.stopPropagation(); } },
            React__default.createElement("input", { autoFocus: true, className: "searchInput " + styles.searchInput, tabIndex: -1, onChange: function (e) { return setSearch(e.target.value); } }),
            foundResults.map(function (result, index) { return (React__default.createElement("button", { key: index, tabIndex: 5000 + 1 + index, className: "result  " + styles.result, onClick: function () { return executeResultAction(result); } }, renderResultRow(result))); }))));
};

exports.ShortcutPopup = ShortcutPopup;
//# sourceMappingURL=index.js.map
